function G=Gradient(q,vol)
% q : d x (d+1)
% G : (d+1) x d
d=size(q,1);
switch d
  case 1
    G=zeros(2,1);
    G(1)=-1/vol;
    G(2)=-G(1);
  case 2
    G=zeros(3,2);M=[0,1;-1,0];
    G(1,:)=M*(q(:,2)-q(:,3))/(2*vol);
    G(2,:)=M*(q(:,3)-q(:,1))/(2*vol);
    G(3,:)=M*(q(:,1)-q(:,2))/(2*vol);
  case 3
    G=zeros(4,3);
    D12=q(:,1)-q(:,2);
    D13=q(:,1)-q(:,3);
    D14=q(:,1)-q(:,4);
    D23=q(:,2)-q(:,3);
    D24=q(:,2)-q(:,4);
    C=1/(6*vol);
  
    G(1,1)=( -D23(2)*D24(3) + D23(3)*D24(2) )*C;
    G(1,2)=(  D23(1)*D24(3) - D23(3)*D24(1) )*C;
    G(1,3)=( -D23(1)*D24(2) + D23(2)*D24(1) )*C;

    G(2,1)=(  D13(2)*D14(3) - D13(3)*D14(2) )*C;
    G(2,2)=( -D13(1)*D14(3) + D13(3)*D14(1) )*C;
    G(2,3)=(  D13(1)*D14(2) - D13(2)*D14(1) )*C;

    G(3,1)=( -D12(2)*D14(3) + D12(3)*D14(2) )*C;
    G(3,2)=(  D12(1)*D14(3) - D12(3)*D14(1) )*C;
    G(3,3)=( -D12(1)*D14(2) + D12(2)*D14(1) )*C;
  
    G(4,1)=(  D12(2)*D13(3) - D12(3)*D13(2) )*C;
    G(4,2)=( -D12(1)*D13(3) + D12(3)*D13(1) )*C;
    G(4,3)=(  D12(1)*D13(2) - D12(2)*D13(1) )*C;
  
  otherwise
    error('dimension d failed')
end